package LoadTables;

import java.awt.*;
import java.sql.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.table.TableColumnModel;
import javax.xml.bind.annotation.adapters.CollapsedStringAdapter;
import javax.swing.ImageIcon.*;
import java.util.Date.*;
import java.text.*;
import java.sql.Timestamp.*;
import java.lang.Object.*;

public class CreateTables {
    

    // Connect to the database
    private StartDB db = new StartDB();
    private InsertDB idb;
    private Timestamp ts;
    private int Employee_ID;
    protected Action seat_C_Action = new Seat_C_Action();
    protected Action change_S_Action = new Change_S_Action();
    // Declaring the variables used in this class
    private String database_query1;
    //private int table_id;
    //private int table_status;
    //private int table_server_id;
    private ResultSet rs;
    private int num_tables=0;
    private int[] t_id=new int[50];
    private int[] t_status=new int[50];
    private int[] t_server_id=new int[50];
    private int[] t_x = new int[50];
    private int[] t_y = new int[50];
    private Color[] status_color = new Color[50];
    private int[] e_id = new int[50];
    private String[] e_firstName = new String[50];
    private String[] e_lastName = new String[50];
    private int i1, i2, i3;
    private JPopupMenu jpop;
    private TableButton selectedTable;
    private Dimension d1;
    
    private void assignOrderId() {
        int orderId;
        ts = new Timestamp( System.currentTimeMillis());
       try {
           db.stmt = db.con.createStatement();
           rs = db.stmt.executeQuery("select max(Order_id) from active_orders");
           
           rs.next();
           
           if(rs.getInt("max(Order_id)") == 0 ) {
                orderId = 1;
           }
           else {
                orderId = rs.getInt("max(Order_id)")+1;
           }
           
           selectedTable.changeTableOrderId(orderId);

           idb = new InsertDB("insert into active_orders (Order_id,Table_id,Employee_id,Menu_item_id,Time,Quantity)" +
              " values (" + orderId + "," + selectedTable.table_id + "," + 
              selectedTable.table_server_id + ",-," + ts + ",0)");
            }
         catch (SQLException ex) { 
               System.err.print("SQLException: ");
               System.err.println(ex.getMessage());
        }
    }
    
    public class Seat_C_Action extends AbstractAction {
        public Seat_C_Action() {}
        public void actionPerformed(ActionEvent evt) {
        idb = new InsertDB("update tabletops set Status=2 where Table_id=" + selectedTable.table_id);
         System.out.println("Before assignOrderId");
        assignOrderId();
        System.out.println("After assignOrderId");
        selectedTable.changeStatus(2);
        selectedTable.changeStatusImage();    
        }
    }
    
    public class Change_S_Action extends AbstractAction {
        private int newServer;
        public Change_S_Action() {}
        public void actionPerformed(ActionEvent evt) {
            newServer = Integer.parseInt(((JMenuItem) evt.getSource()).getName());
        idb = new InsertDB("update tabletops set Employee_id=" + newServer +
                " where Table_id=" + selectedTable.table_id);
        selectedTable.changeEmployeeId(newServer);    
        }
    }

    public CreateTables(JPanel panel, String database_query) {
        database_query1=database_query;
        getTableInfo();
        createPopupMenu();
        addTables(panel);
    }
    //...where instance variables are declared:

    public void clearPanel() {
        
    }
    
    public void createPopupMenu() {
        JMenuItem menuItem;
        JMenu menu;
        int count;

        jpop = new JPopupMenu();
        //Create the popup menu.

        menu = new JMenu("Seat Customer(s)");
        menu.setName("Seat_Customer");
     
        menuItem = new JMenuItem(seat_C_Action);
        menuItem.setText("1");
        menu.add(menuItem, 0);
        
        menuItem = new JMenuItem(seat_C_Action);
        menuItem.setText("2");
        menu.add(menuItem, 1);
        
        menuItem = new JMenuItem(seat_C_Action);
        menuItem.setText("3");
        menu.add(menuItem, 2);
        
        menuItem = new JMenuItem(seat_C_Action);
        menuItem.setText("4");
        menu.add(menuItem, 3);
        
        menuItem = new JMenuItem(seat_C_Action);
        menuItem.setText("5");
        menu.add(menuItem, 4);
        
        menuItem = new JMenuItem(seat_C_Action);
        menuItem.setText("6");
        menu.add(menuItem, 5);
        
        jpop.add(menu, 0);
        jpop.repaint();
        
        menu = new JMenu("Change Server...");
        menu.setName("Change_Server");
        
        count = 0;
        try {
            db.stmt = db.con.createStatement();
            rs = db.stmt.executeQuery("select Employee_id,First_name,Last_name from employees " + 
                    "where Type=3");
            while (rs.next()) { 
               e_id[count] = rs.getInt("Employee_id");
               e_firstName[count] = rs.getString("First_name");
               e_lastName[count] = rs.getString("Last_name");
               count++;
            }       
        } catch (SQLException ex) { 
               System.err.print("SQLException: ");
               System.err.println(ex.getMessage());
        }
        
        for(int j=0;j<count;j++) {   
            menuItem = new JMenuItem(change_S_Action);
            menuItem.setText("ID: "+ e_id[j] + " " + e_firstName[j] + " " + e_lastName[j]);
            menuItem.setName(Integer.toString(e_id[j]));
            menu.add(menuItem, j);
         }
        jpop.add(menu, 1);
        jpop.addSeparator();
        
        menuItem = new JMenuItem("Close");
        jpop.add(menuItem);
        
        MouseListener popupListener = new PopupListener(jpop);
        
    }
   
    private void getTableInfo() {        
        try {
            Statement stmt = db.con.createStatement();
            rs = stmt.executeQuery(database_query1);
            while (rs.next()) { 
               t_id[num_tables] = rs.getInt("Table_id");
               t_server_id[num_tables] = rs.getInt("Employee_id");
               t_status[num_tables] = rs.getInt("Status");
               t_x[num_tables] = rs.getInt("x");
               t_y[num_tables] = rs.getInt("y");
               num_tables = num_tables + 1;
            }       
        } catch (SQLException ex) { 
               System.err.print("SQLException: ");
               System.err.println(ex.getMessage());
        }            
    }
    
    public void addTables(JPanel panel) { 
        MouseListener popupListener = new PopupListener(jpop);
        for(int j=0;j<num_tables;j++) {   
            JButton table = new TableButton(Integer.toString(t_id[j]), t_id[j], t_status[j], t_server_id[j]);
            table.setToolTipText("Table ID: " + t_id[j] + " Table Server ID: " + t_server_id[j]);
            table.setBounds(t_x[j], t_y[j], 35, 35);
            table.addMouseListener(popupListener);     
            panel.add(table);
         }
    }
    
    public class PopupListener extends MouseAdapter {
        JPopupMenu jpop;
        JMenu jmenu;
        PopupListener(JPopupMenu popupMenu) {
            jpop = popupMenu;
        }

        public void mousePressed(MouseEvent e) {
            maybeShowPopup(e);
        }

        public void mouseReleased(MouseEvent e) {
            maybeShowPopup(e);
        }

        private void maybeShowPopup(MouseEvent e) {
                d1 = new Dimension(185,72);
                //jpop.setMaximumSize(d1);
                //jpop.setMinimumSize(d1);
                //jpop.setSize(d1);
                //jpop.setPreferredSize(d1);
                jpop.setPopupSize(d1);
                jpop.show(e.getComponent(), e.getX(), e.getY());
                jpop.repaint();
                jmenu = (JMenu) jpop.getComponent(0);
                TableButton tb1 = (TableButton) e.getSource();
                selectedTable = tb1;               
                jmenu.setText("Seat Customer at Table " + tb1.table_id + "...");
        }
    }
}


