
package order;

import net.rim.device.api.ui.*;
import net.rim.device.api.ui.component.*;
import net.rim.device.api.ui.container.*;
import net.rim.device.api.system.*;

import listcallback.*;
import items.*;


public class Order extends UiApplication { 
    public static void main(String[] args)
    {
        Order theApp = new Order();
        //To make the application enter the event thread and start processing messages, we invoke the enterEventDispatcher method
        theApp.enterEventDispatcher();
    }
    
    public Order() {
        //Push the main screen instance onto the UI stack for rendering.
        pushScreen(new OrderScreen());        
    }
        
    final static class OrderScreen extends MainScreen {
        private  MainScreen  _infoScreen;
        private ObjectListField myList;
        public int n_items=8;
        public String[] items={"Appetizers","Beverages","Bottle Beer","Breakfast","Desserts","Draft Beer","Entrees","Lunches"};
        private int select;
        
        private final int APPETIZERS = 0;
        private final int BEVERAGES  = 1;
        private final int BOTTLEBEER = 2;
        private final int BREAKFAST  = 3;
        private final int DESSERTS   = 4;
        private final int DRAFTBEER  = 5;
        private final int ENTREES    = 6;        
        private final int LUNCH      = 7;
        
        public OrderScreen() {  
            super(DEFAULT_MENU | DEFAULT_CLOSE);
            setTitle(new LabelField("Place an Order", LabelField.ELLIPSIS | LabelField.USE_ALL_WIDTH));            
            showListField();
        }
        
        private MenuItem _closeItem=new MenuItem("Close",2000,10) {
            public void run() {
                onClose();
            }
        };
        
        private void showListField() {                   
            myList = new ObjectListField();
            ListCallback myCallback = new ListCallback();
            myList.setCallback(myCallback);
            for(int i=0;i<n_items;i++) {            
                myCallback.add(myList,items[i],i);
            }
            myList.setSearchable(true);
            add(myList);            
        }
        
        protected void makeMenu( Menu menu, int instance )
        {
                menu.add(_viewItem);
                menu.add(_closeItem);
        }
        
        private MenuItem _viewItem = new MenuItem("Choose Item", 110, 10) {
                public void run() {
                        select = myList.getSelectedIndex();                        
                        System.out.println("select["+select+"] = "+items[select]);
                        switch(select) {
                            case(APPETIZERS):
                                _infoScreen = new Appetizers();
                                UiApplication.getUiApplication().pushScreen(_infoScreen);
                                break;
                            case(BEVERAGES):
                                _infoScreen = new Beverages();
                                UiApplication.getUiApplication().pushScreen(_infoScreen);
                                break;
                            case(BOTTLEBEER):
                                _infoScreen = new BottleBeer();
                                UiApplication.getUiApplication().pushScreen(_infoScreen);
                                break;
                            case(DRAFTBEER):
                                _infoScreen = new DraftBeer();
                                UiApplication.getUiApplication().pushScreen(_infoScreen);
                                break;   
                            case(ENTREES):
                                _infoScreen = new Entrees();
                                UiApplication.getUiApplication().pushScreen(_infoScreen);
                                break;   
                            case(DESSERTS):
                                _infoScreen = new Desserts();
                                UiApplication.getUiApplication().pushScreen(_infoScreen);
                                break;   
                            case(LUNCH):
                                _infoScreen = new Lunch();
                                UiApplication.getUiApplication().pushScreen(_infoScreen);
                                break;   
                            case(BREAKFAST):
                                _infoScreen = new Breakfast();
                                UiApplication.getUiApplication().pushScreen(_infoScreen);
                                break;                          
                        }
                }
        };
        
        public boolean navigationClick(int status, int time) {
            select = myList.getSelectedIndex();
                        switch(select) {
                            case(APPETIZERS):
                                _infoScreen = new Appetizers();
                                UiApplication.getUiApplication().pushScreen(_infoScreen);
                                break;
                            case(BEVERAGES):
                                _infoScreen = new Beverages();
                                UiApplication.getUiApplication().pushScreen(_infoScreen);
                                break;
                            case(BOTTLEBEER):
                                _infoScreen = new BottleBeer();
                                UiApplication.getUiApplication().pushScreen(_infoScreen);
                                break;
                            case(DRAFTBEER):
                                _infoScreen = new DraftBeer();
                                UiApplication.getUiApplication().pushScreen(_infoScreen);
                                break;   
                            case(ENTREES):
                                _infoScreen = new Entrees();
                                UiApplication.getUiApplication().pushScreen(_infoScreen);
                                break;   
                            case(DESSERTS):
                                _infoScreen = new Desserts();
                                UiApplication.getUiApplication().pushScreen(_infoScreen);
                                break;   
                            case(LUNCH):
                                _infoScreen = new Lunch();
                                UiApplication.getUiApplication().pushScreen(_infoScreen);
                                break;       
                            case(BREAKFAST):
                                _infoScreen = new Breakfast();
                                UiApplication.getUiApplication().pushScreen(_infoScreen);
                                break;                                  
                        }
            System.out.println("getselect: "+myList.getSelection());
            System.out.println("select: "+select);
            System.out.println("navclick: "+status+" "+time);
            return true;
        }
    }       
    
    /*public boolean keyChar(char key, int status, int time) {
        //intercept the ESC key - exit the app on its receipt
        boolean retval = false;

        switch (key) {
        case Characters.ESCAPE:
            onClose();
            retval = true;
            break;
        }

        return retval;
    }*/
    public boolean onClose()
    {
        Dialog.alert("Order Exited");
        System.exit(0);
        return true;
    }
         
}
