
package table ;

import net.rim.device.api.ui.*;
import net.rim.device.api.ui.component.*;
import net.rim.device.api.ui.container.*;
import net.rim.device.api.system.*;

import listcallback.*;
import table.*;
import listtables.*;


public class Table extends UiApplication { 
    public static void main(String[] args)
    {
        Table theApp = new Table();
        theApp.enterEventDispatcher();
    }
      
    public Table() {
        pushScreen(new TableScreen());        
    }

    final static class TableScreen extends MainScreen {
        private  MainScreen  _infoScreen;
        public ObjectListField myList;
        public ListCallback myCallback;
        public int n_items=0;
        public String[] items;
        private int select;
        
        private final int TABLE112 = 0;
        private final int TABLE100 = 1;
        private final int TABLE005 = 2;
        
        private ViewTab vt = new ViewTab();
        private CloseTab ct = new CloseTab();
        private MarkTableReady mtr = new MarkTableReady();
        
        public TableScreen() {  
            super(DEFAULT_MENU | DEFAULT_CLOSE);
            setTitle(new LabelField("View Tables", LabelField.ELLIPSIS | LabelField.USE_ALL_WIDTH));
            ListTables theList = new ListTables();
            theList.doQuery("*","tabletops","Table_id","","","");
            n_items=theList.num_items;
            items = new String[n_items];
            items=theList.items; 
            showListField();
        }
        
        private MenuItem _closeItem=new MenuItem("Close",2000,10) {
            public void run() {
                onClose();
            }
        };
                                  
        private void showListField() {            
            myList = new ObjectListField();
            myCallback = new ListCallback();
            myList.setCallback(myCallback);            
            for(int i=0;i<n_items;i++) {
                myCallback.add(myList,items[i],i);
            }
            myList.setSearchable(true);
            add(myList);
            
            vt.myList=myList;
            vt.myCallback=myCallback;
            
            ct.myList=myList;
            ct.myCallback=myCallback;
            
            mtr.myList=myList;
            mtr.myCallback=myCallback;
        }
        
        protected void makeMenu( Menu menu, int instance )
        {
                menu.add(vt._viewTab);
                menu.add(ct._closeTab);
                menu.add(mtr._markTableReady);
        }
        
        private MenuItem _viewTab = new MenuItem("View Tab", 110, 10) {
                public void run() {
                        select = myList.getSelectedIndex();
                }
        };
        
        private MenuItem _closeTab = new MenuItem("Close Tab", 110, 10) {
                public void run() {
                        select = myList.getSelectedIndex();      
                }
        };
        
        private MenuItem _markTableReady = new MenuItem("View Tab", 110, 10) {
                public void run() {
                        select = myList.getSelectedIndex();     
                }
        };
        
        public boolean navigationClick(int status, int time) {
            select = myList.getSelectedIndex();               
            System.out.println("getselect: "+myList.getSelection());
            System.out.println("select: "+select);
            System.out.println("navclick: "+status+" "+time);
            return true;
        }     
     
    public boolean onClose()
    {
        Dialog.alert("Table Exited");
        System.exit(0);
        return true;
    }
  }
}
