

package order;

import net.rim.device.api.ui.*;
import net.rim.device.api.ui.component.*;
import net.rim.device.api.ui.container.*;
import net.rim.device.api.system.*;

import listcallback.*;
import tabs.*;


public class Tabs extends UiApplication { 
    public static void main(String[] args)
    {
        Tabs theApp = new Tabs();
        //To make the application enter the event thread and start processing messages, we invoke the enterEventDispatcher method
        theApp.enterEventDispatcher();
    }
    
    
  

    public Tabs() {
        //Push the main screen instance onto the UI stack for rendering.
        pushScreen(new TabsScreen());        
    }

    final static class TabsScreen extends MainScreen {
        private  MainScreen  _infoScreen;
        public ObjectListField myList;
        public ListCallback myCallback;
        public int n_items=3;
        public String[] items={"Table #112","Table #100","Table #005"};
        private int select;
        private OpenTab ot = new OpenTab();
        private CloseTab ct = new CloseTab();
        
        
        public TabsScreen() {  
            super(DEFAULT_MENU | DEFAULT_CLOSE);
            setTitle(new LabelField("View Tabs", LabelField.ELLIPSIS | LabelField.USE_ALL_WIDTH));
            showListField();
        }
        
        private void showListField() {            
            myList = new ObjectListField();
            myCallback = new ListCallback();
            myList.setCallback(myCallback);            
            for(int i=0;i<n_items;i++) {
                myCallback.add(myList,items[i],i);
            }
            myList.setSearchable(true);
            add(myList);
            ct.myList=myList;
            ct.myCallback=myCallback;
            ot.myList=myList;
            ot.myCallback=myCallback;
        }
        
        protected void makeMenu( Menu menu, int instance )
        {
                menu.add(_viewItem);
                menu.add(ct._closeTab);
                menu.add(ot._openTab);
        }
        
        private MenuItem _viewItem = new MenuItem("View Tab", 110, 10) {
                public void run() {

                        //store the selected city in a variable
                        select = myList.getSelectedIndex();
                        System.out.println("viewing tab #"+select+": "+myCallback.get(myList,select));
                        //display a new screen with information about the
                        //selected city          
                }
        };
        
        public boolean navigationClick(int status, int time) {
            select = myList.getSelectedIndex();               
            System.out.println("getselect: "+myList.getSelection());
            System.out.println("select: "+select);
            System.out.println("navclick: "+status+" "+time);
            return true;
        }
    }       
    
    public boolean keyChar(char key, int status, int time) {
        //intercept the ESC key - exit the app on its receipt
        boolean retval = false;

        switch (key) {
        case Characters.ESCAPE:
            onClose();
            retval = true;
            break;
        }

        return retval;
    }
    public boolean onClose()
    {
        Dialog.alert("Order Exited");
        System.exit(0);
        return true;
    }
}
