package support;

import java.io.*;
import org.kxml.*;
import org.kxml.parser.*;
import org.kxml.kdom.*;

public class DBXMLParser {
  
  public Document doc;
  public DBXMLParser (Reader reader) throws Exception {
    XmlParser parser = new XmlParser (reader);
    doc = new Document();
    doc.parse(parser);
  }

  public DBXMLParser (InputStream ins) throws Exception {
    InputStreamReader reader = new InputStreamReader(ins);
    XmlParser parser = new XmlParser (reader);
    doc = new Document();
    doc.parse(parser);
    }
    
  public int getRowCount( String tableName ) {
    Element root = doc.getRootElement();   
    int result = 0;
    for ( int i = 0 ; i < root.getChildCount(); i++ ) {        
     if ( root.getType(i) == Xml.ELEMENT ) {         
        Element tr = (Element) root.getChild(i);                
        if ( tableName.equals(tr.getName()) ) {          
          result++;
        }
      }
    }
    return result;
  }

  
  public String getFieldValue ( String tableName, String fieldName, 
                                int index ) throws Exception {

    Element root = doc.getRootElement();
    Element row = null, field = null;
    int currentIndex = 0;
    for ( int i=0; i<root.getChildCount(); i++) {
      if ( root.getType(i) == Xml.ELEMENT ) {
        Element tr = (Element) root.getChild(i);
        if ( tableName.equals( tr.getName() ) ) {
          if ( currentIndex == index ) {
            row = (Element) root.getChild(i);
            break;
          }
          currentIndex++;
        }
      }
    }
    if ( row == null ) {
      return null;
    }
    for ( int i=0; i<row.getChildCount(); i++) {
      if ( row.getType(i) == Xml.ELEMENT ) {
        Element tf = (Element) row.getChild(i);
        // Match the fieldName to tag name.
        if ( fieldName.equals( tf.getName() ) ) {
          field = tf;
          break;
        }
      }
    }
    if ( field == null ) {
      return null;
    } else {
      return field.getText(0);
    }
  }
 
  public static String rowString (String tableName, String[] fieldNames,
                                  String[] fieldValues) throws Exception {

    StringBuffer sb = new StringBuffer();
    sb.append("<"+tableName+">");
    for (int i=0; i<fieldNames.length; i++) {
      sb.append("<"+fieldNames[i]+">");
      if ( fieldValues[i] != null ) {
        sb.append(fieldValues[i]);
      }
      sb.append("</"+fieldNames[i]+">");
    }
    sb.append("</"+tableName+">");
    return sb.toString();
  }

  public String toString () {
    return doc.toString();
  }
}
